                processor 6502 
                include "vcs.h" 
                include "macro.h" 
                include "jumpmacro.h" 

    SEG.U vars
    ORG $80

customarea1         ds 3
customarea2         ds 3
customarea3         ds 3
customarea4         ds 3
customarea5         ds 3
customarea6         ds 3
customarea7         ds 3
customarea8         ds 3
customarea9         ds 3
customarea10        ds 3
customarea11        ds 3
customarea12        ds 3

frameCounter        ds 1

    SEG Bank0
    ORG $F000 

Start
    CLEAN_START
    LDA #$A2
    STA COLUPF
    LDA #1
    STA CTRLPF

    JSR BombsInit

Start_Frame 
    VERTICAL_SYNC

; Vertical Blank

    LDX 37
Vertical_Blank  
    STA WSYNC 
    DEX 
    BNE Vertical_Blank 

; Kernel
    STA VBLANK  ; Enable TIA Output

    SYMMETRICALJUMPMANKERNEL JUMP_PF1-BOMBS_TOP, BOMBS_TOP-JUMP_PF0
    CUSTOMPF1PF2JUMPMANKERNEL 3, BOMBS_CUSTOM1-JUMP_PF0, customarea1, customarea2, customarea3, customarea4
    SYMMETRICALJUMPMANKERNEL BOMBS_CUSTOM1-BOMBS_MIDDLE1, BOMBS_MIDDLE1-JUMP_PF0
    CUSTOMPF1PF2JUMPMANKERNEL 3, BOMBS_CUSTOM2-JUMP_PF0, customarea5, customarea6, customarea7, customarea8
    SYMMETRICALJUMPMANKERNEL BOMBS_CUSTOM2-BOMBS_MIDDLE2, BOMBS_MIDDLE2-JUMP_PF0
    CUSTOMPF1PF2JUMPMANKERNEL 3, BOMBS_CUSTOM3-JUMP_PF0, customarea9, customarea10, customarea11, customarea12
    SYMMETRICALJUMPMANKERNEL BOMBS_CUSTOM3-JUMP_PF0, 0

    STA WSYNC
    LDA #0
    STA PF0
    STA PF1
    STA PF2
    LDA #2      ; Disable TIA Output
    STA VBLANK           

; Overscan
    
    LDX #30 
Overscan        STA WSYNC 
    DEX 
    BNE Overscan 

; Test code for custom zones!
    JSR BombsInit
    INC frameCounter
    LDA frameCounter
    LSR
    LSR
    LSR
    BCC FirstZoneFine

    TAY
    LDX 2
Zone1
    LDA customarea1,X
    AND #%11100000
    STA customarea1,X
    LDA customarea3,X
    AND #%11111100
    STA customarea3,X
    DEX
    BPL Zone1
    TYA
    
FirstZoneFine
    LSR
    BCC SecondZoneFine

    TAY
    LDX 2
Zone2
    LDA customarea2,X
    AND #%11100000
    STA customarea2,X
    LDA customarea4,X
    AND #%11111100
    STA customarea4,X
    DEX
    BPL Zone2
    TYA

SecondZoneFine
    LSR
    BCC ThirdZoneFine

    TAY
    LDX 2
Zone3
    LDA customarea5,X
    AND #%11100000
    STA customarea5,X
    LDA customarea7,X
    AND #%11111100
    STA customarea7,X
    DEX
    BPL Zone3
    TYA

ThirdZoneFine
    LSR
    BCC FourthZoneFine

    TAY
    LDX 2
Zone4
    LDA customarea6,X
    AND #%11100000
    STA customarea6,X
    LDA customarea8,X
    AND #%11111100
    STA customarea8,X
    DEX
    BPL Zone4
    TYA

FourthZoneFine
    LSR
    BCC FifthZoneFine

    TAY
    LDX 2
Zone5
    LDA customarea9,X
    AND #%11100000
    STA customarea9,X
    LDA customarea11,X
    AND #%11111100
    STA customarea11,X
    DEX
    BPL Zone5
    TYA

FifthZoneFine
    LSR
    BCC Done

    TAY
    LDX 2
Zone6
    LDA customarea10,X
    AND #%11100000
    STA customarea10,X
    LDA customarea12,X
    AND #%11111100
    STA customarea12,X
    DEX
    BPL Zone6
    TYA
    
Done    

    JMP Start_Frame     ; Build Next Frame

; Initing sub ->DEBUG<-

BombsInit
; Init Custom kernel zones    
    LDX 2
InitCustomZones
    LDA JUMP_PF1+BOMBS_CUSTOM1-JUMP_PF0,X
    STA customarea1,X
    STA customarea2,X
    LDA JUMP_PF2+BOMBS_CUSTOM1-JUMP_PF0,X
    STA customarea3,X
    STA customarea4,X
    LDA JUMP_PF1+BOMBS_CUSTOM2-JUMP_PF0,X
    STA customarea5,X
    STA customarea6,X
    LDA JUMP_PF2+BOMBS_CUSTOM2-JUMP_PF0,X
    STA customarea7,X
    STA customarea8,X
    LDA JUMP_PF1+BOMBS_CUSTOM3-JUMP_PF0,X
    STA customarea9,X
    STA customarea10,X
    LDA JUMP_PF2+BOMBS_CUSTOM3-JUMP_PF0,X
    STA customarea11,X
    STA customarea12,X
    DEX
    BPL InitCustomZones
    RTS

; Data

    ORG $F800

JUMP_PF0
                                .byte   %11100000
                                .byte   %11100000
                                .byte   %11100000
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
BOMBS_CUSTOM3
                                .byte   %11100000
                                .byte   %11100000
                                .byte   %11100000
BOMBS_MIDDLE2
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
BOMBS_CUSTOM2
                                .byte   %11100000
                                .byte   %11100000
                                .byte   %11100000
BOMBS_MIDDLE1
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
BOMBS_CUSTOM1
                                .byte   %11100000
                                .byte   %11100000
                                .byte   %11100000
BOMBS_TOP
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %11100000
                                .byte   %11100000
                                .byte   %11100000
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000

JUMP_PF1
                                .byte   %11111111
                                .byte   %11111111
                                .byte   %11111111
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00001111
                                .byte   %10001111
                                .byte   %00001111
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %11111111
                                .byte   %11111111
                                .byte   %11111111
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %11111111
                                .byte   %11111111
                                .byte   %11111111
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %11111111
                                .byte   %11111111
                                .byte   %11111111
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %11100011
                                .byte   %11100011
                                .byte   %11100011
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000

    ORG $F900

JUMP_PF2
                                .byte   %11111111
                                .byte   %11111111
                                .byte   %11111111
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00001111
                                .byte   %00001111
                                .byte   %00001111
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00001111
                                .byte   %00001111
                                .byte   %00001111
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00001111
                                .byte   %00001111
                                .byte   %00001111
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %11110001
                                .byte   %11110001
                                .byte   %11110001
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000

    ORG $FFFA
    .WORD Start
    .WORD Start
    .WORD Start