                processor 6502 
                include "vcs.h" 
                include "macro.h" 
                include "jumpmacro.h" 

    SEG.U vars
    ORG $80

customarea1         ds 4
customarea2         ds 4
customarea3         ds 5
customarea4         ds 5
customarea5         ds 5
customarea6         ds 5

frameCounter        ds 1

    SEG Bank0
    ORG $F000 

Start
    CLEAN_START
    LDA #$A2
    STA COLUPF
    LDA #1
    STA CTRLPF

    JSR EasyInit

Start_Frame 
    VERTICAL_SYNC

; Vertical Blank

    LDX 37
Vertical_Blank  
    STA WSYNC 
    DEX 
    BNE Vertical_Blank 

; Kernel
    STA VBLANK  ; Enable TIA Output

    SYMMETRICALJUMPMANKERNEL JUMP_PF1-EASY_TOP, EASY_TOP-JUMP_PF0
    CUSTOMPF1JUMPMANKERNEL 4, EASY_CUSTOM1-JUMP_PF0, customarea1, customarea2
    SYMMETRICALJUMPMANKERNEL EASY_CUSTOM1-EASY_MIDDLE, EASY_MIDDLE-JUMP_PF0
    CUSTOMPF0PF1JUMPMANKERNEL 5, EASY_CUSTOM2-JUMP_PF0, customarea3, customarea4, customarea5, customarea6
    SYMMETRICALJUMPMANKERNEL EASY_CUSTOM2-JUMP_PF0, 0

    STA WSYNC
    LDA #0
    STA PF0
    STA PF1
    STA PF2
    LDA #2      ; Disable TIA Output
    STA VBLANK           

; Overscan
    
    LDX #30 
Overscan        STA WSYNC 
    DEX 
    BNE Overscan 

; Test code for custom zones!
    JSR EasyInit
    INC frameCounter
    LDA frameCounter
    LSR
    LSR
    LSR
    LSR
    LSR
    BCC FirstZoneFine

    TAY
    LDX 3
Zone1
    LDA customarea1,X
    AND #%11000111
    STA customarea1,X
    DEX
    BPL Zone1
    TYA
    
FirstZoneFine
    LSR
    BCC SecondZoneFine

    TAY
    LDX 3
Zone2
    LDA customarea2,X
    AND #%11000111
    STA customarea2,X
    DEX
    BPL Zone2
    TYA

SecondZoneFine
    LSR
    BCC ThirdZoneFine

    LDX 4
    LDY #0
Zone3
    STY customarea3,X
    STY customarea5,X
    DEX
    BPL Zone3

ThirdZoneFine
    LSR
    BCC Done

    LDX 4
    LDY #0
Zone4
    STY customarea4,X
    STY customarea6,X
    DEX
    BPL Zone4
    
Done    

    JMP Start_Frame     ; Build Next Frame

; Initing sub ->DEBUG<-

EasyInit
; Init Custom kernel zones    
    LDX 4
InitCustomZones
    LDA JUMP_PF1+EASY_CUSTOM1-JUMP_PF0,X
    STA customarea1,X
    STA customarea2,X
    LDA JUMP_PF0+EASY_CUSTOM2-JUMP_PF0,X
    STA customarea3,X
    STA customarea4,X
    LDA JUMP_PF1+EASY_CUSTOM2-JUMP_PF0,X
    STA customarea5,X
    STA customarea6,X
    DEX
    BPL InitCustomZones
    RTS

; Data

    ORG $F800

JUMP_PF0
    .byte #%11100000    ; Scanline 95
    .byte #%11100000    ; Scanline 94
    .byte #%11100000    ; Scanline 93
    .byte #%00000000    ; Scanline 92
    .byte #%10000000    ; Scanline 91
    .byte #%00000000    ; Scanline 90
    .byte #%10000000    ; Scanline 89
    .byte #%00000000    ; Scanline 88
    .byte #%10000000    ; Scanline 87
    .byte #%00000000    ; Scanline 86
    .byte #%10000000    ; Scanline 85
    .byte #%00000000    ; Scanline 84
    .byte #%10000000    ; Scanline 83
    .byte #%00000000    ; Scanline 82
    .byte #%10000000    ; Scanline 81
    .byte #%00000000    ; Scanline 80
    .byte #%11100000    ; Scanline 79
    .byte #%11100000    ; Scanline 78
    .byte #%11100000    ; Scanline 77
    .byte #%00000000    ; Scanline 76
    .byte #%10000000    ; Scanline 75
    .byte #%00000000    ; Scanline 74
    .byte #%10000000    ; Scanline 73
    .byte #%00000000    ; Scanline 72
    .byte #%00000000    ; Scanline 71
    .byte #%00000000    ; Scanline 70
    .byte #%00000000    ; Scanline 69
    .byte #%00000000    ; Scanline 68
    .byte #%00000000    ; Scanline 67
    .byte #%00000000    ; Scanline 66
    .byte #%00000000    ; Scanline 65
    .byte #%00000000    ; Scanline 64
    .byte #%00000000    ; Scanline 63
    .byte #%00000000    ; Scanline 62
    .byte #%00000000    ; Scanline 61
    .byte #%00000000    ; Scanline 60
    .byte #%00000000    ; Scanline 59
    .byte #%00000000    ; Scanline 58
    .byte #%10000000    ; Scanline 57
    .byte #%00000000    ; Scanline 56
    .byte #%11100000    ; Scanline 55
    .byte #%11100000    ; Scanline 54
    .byte #%11100000    ; Scanline 53
    .byte #%00000000    ; Scanline 52
    .byte #%10000000    ; Scanline 51
    .byte #%00000000    ; Scanline 50
    .byte #%10000000    ; Scanline 49
    .byte #%00000000    ; Scanline 48
EASY_CUSTOM2
    .byte #%10000000    ; Scanline 47
    .byte #%00000000    ; Scanline 46
    .byte #%10000000    ; Scanline 45
    .byte #%00000000    ; Scanline 44
    .byte #%10000000    ; Scanline 43
EASY_MIDDLE
    .byte #%00000000    ; Scanline 42
    .byte #%10000000    ; Scanline 41
    .byte #%00000000    ; Scanline 40
    .byte #%11100000    ; Scanline 39
    .byte #%11100000    ; Scanline 38
    .byte #%11100000    ; Scanline 37
    .byte #%00000000    ; Scanline 36
    .byte #%10000000    ; Scanline 35
    .byte #%00000000    ; Scanline 34
    .byte #%10000000    ; Scanline 33
    .byte #%00000000    ; Scanline 32
    .byte #%10000000    ; Scanline 31
    .byte #%00000000    ; Scanline 30
    .byte #%10000000    ; Scanline 29
    .byte #%00000000    ; Scanline 28
    .byte #%10000000    ; Scanline 27
    .byte #%00000000    ; Scanline 26
    .byte #%10000000    ; Scanline 25
    .byte #%00000000    ; Scanline 24
    .byte #%10000000    ; Scanline 23
    .byte #%00000000    ; Scanline 22
EASY_CUSTOM1
    .byte #%10000000    ; Scanline 21
    .byte #%00000000    ; Scanline 20
    .byte #%11100000    ; Scanline 19
    .byte #%11100000    ; Scanline 18
EASY_TOP
    .byte #%11100000    ; Scanline 17
    .byte #%00000000    ; Scanline 16
    .byte #%10000000    ; Scanline 15
    .byte #%00000000    ; Scanline 14
    .byte #%10000000    ; Scanline 13
    .byte #%00000000    ; Scanline 12
    .byte #%00000000    ; Scanline 11
    .byte #%00000000    ; Scanline 10
    .byte #%00000000    ; Scanline 9
    .byte #%00000000    ; Scanline 8
    .byte #%00000000    ; Scanline 7
    .byte #%00000000    ; Scanline 6
    .byte #%00000000    ; Scanline 5
    .byte #%00000000    ; Scanline 4
    .byte #%00000000    ; Scanline 3
    .byte #%00000000    ; Scanline 2
    .byte #%00000000    ; Scanline 1
    .byte #%00000000    ; Scanline 0

JUMP_PF1
                                .byte   %11111111
                                .byte   %11111111
                                .byte   %11111111
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %11100000
                                .byte   %11110000
                                .byte   %11111000
                                .byte   %00011100
                                .byte   %10001110
                                .byte   %00000111
                                .byte   %10000011
                                .byte   %00000001
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %11000110
                                .byte   %11000110
                                .byte   %11000110
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %11000000
                                .byte   %11000000
                                .byte   %11000000
                                .byte   %00000000
                                .byte   %10000011
                                .byte   %00000011
                                .byte   %10000011
                                .byte   %00000000
                                .byte   %10000001
                                .byte   %00000000
                                .byte   %10000001
                                .byte   %00000000
                                .byte   %10000001
                                .byte   %00000000
                                .byte   %10000001
                                .byte   %00000000
                                .byte   %10000001
                                .byte   %00000000
                                .byte   %10010001
                                .byte   %00111000
                                .byte   %11111111
                                .byte   %11101111
                                .byte   %11000111
                                .byte   %00000000
                                .byte   %10000001
                                .byte   %00000000
                                .byte   %10000001
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000

    ORG $F900

JUMP_PF2
                                .byte   %11111111
                                .byte   %11111111
                                .byte   %11111111
                                .byte   %11000000
                                .byte   %11000000
                                .byte   %11000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000001
                                .byte   %00000011
                                .byte   %11111111
                                .byte   %11111110
                                .byte   %11111100
                                .byte   %00000000
                                .byte   %00011000
                                .byte   %00000000
                                .byte   %00011000
                                .byte   %00000000
                                .byte   %00011000
                                .byte   %00000000
                                .byte   %00011000
                                .byte   %00000000
                                .byte   %00011000
                                .byte   %00000000
                                .byte   %00011000
                                .byte   %00000000
                                .byte   %11111100
                                .byte   %11111100
                                .byte   %11111100
                                .byte   %00000000
                                .byte   %10011000
                                .byte   %00000000
                                .byte   %10011000
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %11100000
                                .byte   %11110000
                                .byte   %11111000
                                .byte   %00011100
                                .byte   %10001111
                                .byte   %00000111
                                .byte   %10000011
                                .byte   %00000000
                                .byte   %00000001
                                .byte   %00000000
                                .byte   %00000001
                                .byte   %00000000
                                .byte   %00000001
                                .byte   %00000000
                                .byte   %00000001
                                .byte   %00000000
                                .byte   %00000001
                                .byte   %00000000
                                .byte   %00000001
                                .byte   %00000000
                                .byte   %00000111
                                .byte   %00001111
                                .byte   %00011111
                                .byte   %00111000
                                .byte   %00110001
                                .byte   %00100000
                                .byte   %00000001
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000

    ORG $FFFA
    .WORD Start
    .WORD Start
    .WORD Start