                processor 6502 
                include "vcs.h" 
                include "macro.h" 
                include "jumpmacro.h" 

    SEG.U vars
    ORG $80

customarea1         ds 3
customarea3         ds 5
customarea4         ds 5

frameCounter        ds 1

    SEG Bank0
    ORG $F000 

Start
    CLEAN_START
    LDA #$A2
    STA COLUPF
    LDA #1
    STA CTRLPF

    JSR EasyInit

Start_Frame 
    VERTICAL_SYNC

; Vertical Blank

    LDX 37
Vertical_Blank  
    STA WSYNC 
    DEX 
    BNE Vertical_Blank 

; Kernel
    STA VBLANK  ; Enable TIA Output

    SYMMETRICALJUMPMANKERNEL JUMP_PF1-EASY_TOP, EASY_TOP-JUMP_PF0
    CUSTOMSYMMETRICALPF2KERNEL EASY_TOP-EASY_CUSTOM1, EASY_CUSTOM1-JUMP_PF0, customarea1
    SYMMETRICALJUMPMANKERNEL EASY_CUSTOM1-EASY_MIDDLE, EASY_MIDDLE-JUMP_PF0
    CUSTOMPF1JUMPMANKERNEL EASY_MIDDLE-EASY_CUSTOM2, EASY_CUSTOM2-JUMP_PF0, customarea3, customarea4
    SYMMETRICALJUMPMANKERNEL EASY_CUSTOM2-JUMP_PF0, 0

    STA WSYNC
    LDA #0
    STA PF0
    STA PF1
    STA PF2
    LDA #2      ; Disable TIA Output
    STA VBLANK           

; Overscan
    
    LDX #30 
Overscan        STA WSYNC 
    DEX 
    BNE Overscan 

; Test code for custom zones!
    JSR EasyInit
    INC frameCounter
    LDA frameCounter
    LSR
    LSR
    LSR
    LSR
    LSR
    LSR
    BCC FirstZoneFine

    TAY
    LDX #2
Zone1
    LDA customarea1,X
    AND #%01111111
    STA customarea1,X
    DEX
    BPL Zone1
    TYA
    
FirstZoneFine
    LSR
    BCC ThirdZoneFine

    LDX #4
    LDY #0
Zone3
    STY customarea3,X
    DEX
    BPL Zone3

ThirdZoneFine
    LSR
    BCC Done

    LDX #4
    LDY #0
Zone4
    STY customarea4,X
    DEX
    BPL Zone4
    
Done    

    JMP Start_Frame     ; Build Next Frame

; Initing sub ->DEBUG<-

EasyInit
; Init Custom kernel zones    
    LDX 4
InitCustomZones
    LDA JUMP_PF2+EASY_CUSTOM1-JUMP_PF0,X
    STA customarea1,X
    LDA JUMP_PF1+EASY_CUSTOM2-JUMP_PF0,X
    STA customarea3,X
    STA customarea4,X
    DEX
    BPL InitCustomZones
    RTS

; Data

    ORG $F800

JUMP_PF0
                                .byte   %11100000
                                .byte   %11100000
                                .byte   %11100000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %11000000
                                .byte   %11000000
                                .byte   %11000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
EASY_CUSTOM2
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
EASY_MIDDLE
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %10000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %11100000
                                .byte   %11100000
                                .byte   %11100000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
EASY_CUSTOM1
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
EASY_TOP
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %11100000
                                .byte   %11100000
                                .byte   %11100000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000

JUMP_PF1
                                .byte   %11111000
                                .byte   %11111000
                                .byte   %11111000
                                .byte   %00000000
                                .byte   %11000000
                                .byte   %00000000
                                .byte   %11000000
                                .byte   %00000000
                                .byte   %11000000
                                .byte   %00000000
                                .byte   %11000000
                                .byte   %00000000
                                .byte   %11000000
                                .byte   %00000000
                                .byte   %11000000
                                .byte   %00000000
                                .byte   %11000000
                                .byte   %00000000
                                .byte   %11000000
                                .byte   %00000000
                                .byte   %11111110
                                .byte   %11111110
                                .byte   %11111110
                                .byte   %00000000
                                .byte   %11000000
                                .byte   %00000000
                                .byte   %11000000
                                .byte   %00000000
                                .byte   %11000000
                                .byte   %00000000
                                .byte   %11000000
                                .byte   %00000000
                                .byte   %11000000
                                .byte   %00000000
                                .byte   %11000000
                                .byte   %00000000
                                .byte   %11111111
                                .byte   %11111111
                                .byte   %11111111
                                .byte   %00000000
                                .byte   %11000000
                                .byte   %00000000
                                .byte   %11000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00011111
                                .byte   %00111111
                                .byte   %01111111
                                .byte   %11100000
                                .byte   %11000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00011111
                                .byte   %00011111
                                .byte   %00011111
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000

    ORG $F900

JUMP_PF2
                                .byte   %00000110
                                .byte   %00001110
                                .byte   %00011110
                                .byte   %00111000
                                .byte   %11110000
                                .byte   %11100000
                                .byte   %11000000
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %11111000
                                .byte   %11111000
                                .byte   %11111000
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %11100001
                                .byte   %11100001
                                .byte   %11100001
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %11100001
                                .byte   %11100001
                                .byte   %11100001
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %11000000
                                .byte   %11100000
                                .byte   %01110000
                                .byte   %00111000
                                .byte   %00011100
                                .byte   %00001110
                                .byte   %00000111
                                .byte   %00000011
                                .byte   %00000001
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00010000
                                .byte   %01110000
                                .byte   %11110000
                                .byte   %11100000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000

    ORG $FFFA
    .WORD Start
    .WORD Start
    .WORD Start